> ## Documentation Index
> Fetch the complete documentation index at: https://docs.procuros.io/llms.txt
> Use this file to discover all available pages before exploring further.

# Sales Reports

This is the right section for you if you are acting as a supplier and looking to receive sales reports from your buyers.

Throughout this guide you will learn how to pull new sales reports from the Procuros API, as well as how to paginate over them, mark them as processed, or report errors with the sales reports.

It is important to mark the sales reports as processed (either successfully or not) so that the Procuros network can communicate this to your trade partners. This will also prevent them from re-appearing in future `GET` requests for transactions data, as well as trigger the error management process in case you mark any documents as "processing failed".\*\*\*\*

PHP examples are included but you will likely also want to look at the relevant API calls in the [API reference](/en/api/v2/incoming-transactions/list-incoming-transactions).

<Note>
  Trade partners may send updated versions of a document. Always check the `isLatestVersion` field before importing — if it is `false`, a newer version exists and this one should be skipped. See [Document Versioning](/en/api/v2/features-document-versioning) for full details.
</Note>

## Authentication

You will need an API token to authenticate. We use a bearer token which has to be included in each request you send to the API.

Please read the [Authentication](/en/api/v2/concept-authentication) section of our API reference for a detailed description.

## Error Handling

The API will return a 2xx status code for successful requests. Anything else indicates an error.

Please read the [Errors](/en/api/v2/concept-error-handling) section of our API reference for a detailed description plus examples of how to handle them.

## Pull New Sales Reports

The API call [List incoming Transactions](/en/api/v2/incoming-transactions/list-incoming-transactions) is used to fetch all incoming transactions.

<CodeGroup>
  ```php php theme={null}
  // install dependency
  // $ composer require guzzlehttp/guzzle

  <?php
  require_once('vendor/autoload.php');

  $client = new \GuzzleHttp\Client();

  $response = $client->request('GET', 'https://api.procuros.io/v2/transactions?filter[type]=SALES_REPORT', [
    'headers' => [
      'Accept' => 'application/json',
      'Authorization' => 'Bearer <your-api-token>',
    ],
  ]);

  $body = json_decode((string) $response->getBody());

  $items = $body->items;
  ```
</CodeGroup>

### Pagination

The response body has a `hasMore` flag. If it's `true` not all items are in the response.

You will then want to fetch the other items as well. Therefore, you can use the `nextPageUrl` flag from the response body and perform the same request with the new URL again.

<CodeGroup>
  ```php php theme={null}
  if ($body->hasMore) {
  	$response = $client->request('GET', $body->nextPageUrl, [
      'headers' => [
        'Accept' => 'application/json',
        'Authorization' => 'Bearer <your-api-token>',
      ],
    ]);

    ... // don't forget to check for errors

    $body = json_decode((string) $response->getBody());

    $items = array_merge($items, $body->items);
  }
  ```
</CodeGroup>

<Info>
  If you are running your code only once a day or so, we recommend to perform the request with the new URL until `hasMore` is false. When doing so you can be sure to fetch all currently available items.
</Info>

Please read the [Pagination](/en/api/v2/concept-pagination) section of our API reference for a detailed description.

## Mark Sales Reports as Processed

To mark a sales report as processed, use the API call [Mark transaction processed](/en/api/v2/incoming-transactions/mark-transaction-processed).

On the happy path of a transaction being processed successfully, you can make an API call such as:

<CodeGroup>
  ```php php theme={null}
  require_once('vendor/autoload.php');

  $client = new \GuzzleHttp\Client();

  $transaction_id = 'abc-123'; // Get the transaction ID from the original `GET /v2/transactions` call
  $response = $client->request('POST', "https://api.procuros.io/v2/transactions/{$transaction_id}", [
    'headers' => [
      'Accept' => 'application/json',
      'Authorization' => 'Bearer <your-api-token>',
    ],
    'json' => [
      'success' => true
    ]
  ]);

  ... // Remember to check the request was successful
  ```
</CodeGroup>

### Mark Multiple Sales Reports as Processed

In addition to the above, you can specify a list of items that should be marked as processed in a single API call, via the [Bulk mark transactions processed](/en/api/v2/incoming-transactions/bulk-mark-transactions-processed) endpoint.

<CodeGroup>
  ```php php theme={null}
  require_once('vendor/autoload.php');

  $client = new \GuzzleHttp\Client();

  // You can find the IDs from the original `GET /v2/transactions` call
  $items = [
    [
      'procurosTransactionId' => 'abc-123',
      'success' => true
    ],
    [
      'procurosTransactionId' => 'def-456',
      'success' => true
    ]
  ];

  $response = $client->request('POST', "https://api.procuros.io/v2/transactions/bulk/mark-processed", [
    'headers' => [
      'Accept' => 'application/json',
      'Authorization' => 'Bearer <your-api-token>',
    ],
    'json' => [
      'items' => $items
    ]
  ]);

  ... // Remember to check the request was successful
  ```
</CodeGroup>

## Report an Error Processing Sales Reports

In the event a sales report was not able to be processed, you can use the same 2 API calls listed above ([Mark transaction processed](/en/api/v2/incoming-transactions/mark-transaction-processed) and [Bulk mark transactions processed](/en/api/v2/incoming-transactions/bulk-mark-transactions-processed)) to mark these sales reports as "failed to process".

In this case you must set the `success` flag to `false`. Additionally you should (but are not required to) add a `reason` for the sales report not being processed, which will be used for solving the issue.

### Single Sales Report

<CodeGroup>
  ```php php theme={null}
  $transaction_id = 'abc-123';
  $response = $client->request('POST', "https://api.procuros.io/v2/transactions/{$transaction_id}", [
    'headers' => [
      'Accept' => 'application/json',
      'Authorization' => 'Bearer <your-api-token>',
    ],
    'json' => [
      'success' => false,
      'reason' => 'Missing location details in sales report'
    ]
  ]);
  ```
</CodeGroup>

### Bulk Error Reporting

<CodeGroup>
  ```php php theme={null}
  $items = [
    [
      'procurosTransactionId' => 'abc-123',
      'success' => false,
      'reason' => 'Missing location details in sales report'
    ],
    [
      'procurosTransactionId' => 'def-456',
      'success' => true
    ],
  ];

  $response = $client->request('POST', "https://api.procuros.io/v2/transactions/bulk/mark-processed", [
    'headers' => [
      'Accept' => 'application/json',
      'Authorization' => 'Bearer <your-api-token>',
    ],
    'json' => [
      'items' => $items
    ]
  ]);
  ```
</CodeGroup>
